# -----------------------------------------------------------------------------$)C
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-A|cken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ==== coala_analyze_round_in_detail 
# ==== analyze actions between coalitions at each round
proc coala_analyze_round_in_detail {} {
    global c_font

    set w .analyze
    destroy $w.f1
    destroy $w.f2

    # ===== make "new" special frame
    frame $w.f1
    pack $w.f1 -side top -fill x -in $w.right

    frame $w.f1.f1
    pack $w.f1.f1 -in $w.f1 -fill x
    label $w.f1.l1 -text "Round: "
    coala_bind_help $w.f1.l1 "coala_shorthelp ana1_neg_round.hlp"
    pack $w.f1.l1 -in $w.f1.f1 -side left

	global round_num a_agents max_round simulation_name selected_neg
	set round_num 1
	# ==== read number of rounds in this negotiation    
	set max_round 0
	set logfile [open "logs/$simulation_name\.$selected_neg\.log" r]
	# ===== read formation after each round
	while {![eof $logfile]} {
   		gets $logfile line
		if {[lindex $line 0] == "round"} {
			incr max_round
		}
	}
	close $logfile

    entry $w.f1.round -textvariable round_num -width 4
    pack $w.f1.round -in $w.f1.f1 -fill x -side left
    coala_bind_help $w.f1.round "coala_shorthelp ana1_neg_round.hlp"

	# ==== go button
    button $w.f1.go_rnd -text "Go!" -command {
		global round_num max_round
		if {![coala_positive_int $round_num] || $round_num > $max_round || $round_num < 1} {
			coala_message "Error" "Please, insert a number between 1 and $max_round"
		    .analyze.f1.plus configure -state disabled
		    .analyze.f1.minus configure -state disabled
			focus .analyze
			focus .analyze.f1.round
			return
		}

		if {$round_num == $max_round} {
		    .analyze.f1.plus configure -state disabled
		} else {
		    .analyze.f1.plus configure -state normal
		}
		if {$round_num == 1} {
		    .analyze.f1.minus configure -state disabled
		} else {
		    .analyze.f1.minus configure -state normal
		}
		coala_display_sub_item
	}
    pack $w.f1.go_rnd -in $w.f1.f1 -side right 
    coala_bind_help $w.f1.go_rnd "coala_shorthelp ana1_round_go.hlp"


    # ===== push for next round
    button $w.f1.plus -text "Next Round" -command {
		global round_num max_round
		if {![coala_positive_int $round_num] || $round_num > $max_round || $round_num < 1} {
			coala_message "Error" "Please, insert a number between 1 and $max_round"
		    .analyze.f1.plus configure -state disabled
		    .analyze.f1.minus configure -state disabled
			focus .analyze
			focus .analyze.f1.round
			return
		}
		if {$round_num == $max_round} {
			coala_message "Error" "This is the Last Round"
		    .analyze.f1.plus configure -state disabled
			focus .analyze
			focus .analyze.f1.round
			return
		}

		incr round_num
		if {$round_num == $max_round} {
		    .analyze.f1.plus configure -state disabled
		} else {
		    .analyze.f1.plus configure -state normal
		}
		if {$round_num == 1} {
		    .analyze.f1.minus configure -state disabled
		} else {
		    .analyze.f1.minus configure -state normal
		}
		coala_display_sub_item
    }
    coala_bind_help $w.f1.plus "coala_shorthelp ana1_next_round.hlp"

	# ==== button for previous round
	button $w.f1.minus -text "Previous Round" -command {
		global round_num max_round
		if {![coala_positive_int $round_num] || $round_num > $max_round || $round_num < 1} {
			coala_message "Error" "Please, insert a number between 1 and $max_round"
		    .analyze.f1.plus configure -state disabled
		    .analyze.f1.minus configure -state disabled
			focus .analyze
			focus .analyze.f1.round
			return
		}
		if {$round_num == 1} {
			coala_message "Error" "This is the First Round"
		    .analyze.f1.plus configure -state disabled
			focus .analyze
			focus .analyze.f1.round
			return
		}

		incr round_num -1
		if {$round_num == $max_round} {
		    .analyze.f1.plus configure -state disabled
		} else {
		    .analyze.f1.plus configure -state normal
		}
		if {$round_num == 1} {
		    .analyze.f1.minus configure -state disabled
		} else {
		    .analyze.f1.minus configure -state normal
		}
		coala_display_sub_item
	}
    coala_bind_help $w.f1.minus "coala_shorthelp ana1_prev_round.hlp"
    
	pack $w.f1.plus -in $w.f1 -fill x 
	pack $w.f1.minus -in $w.f1 -fill x
	$w.f1.minus configure -state disabled

	global sub_display_type opt_sim
    # ====== radiobuttons for display type
	if {[lindex $opt_sim 3] != 1 && [lindex $opt_sim 3] != 7} {
		radiobutton $w.f1.trust -text "Trust Relations" -variable sub_display_type -value 1 \
			-anchor w -command {coala_display_neg_trust_relations}
		pack $w.f1.trust -in $w.f1 -fill x 
	    coala_bind_help $w.f1.trust "coala_shorthelp ana1_rb_trust_relation.hlp"
	}

    radiobutton $w.f1.proposal -text "Coalition Proposals" -variable sub_display_type -value 2 \
		-anchor w -command {coala_display_neg_proposal}
    pack $w.f1.proposal -in $w.f1 -fill x 
    coala_bind_help $w.f1.proposal "coala_shorthelp ana1_rb_coal_prop.hlp"


    radiobutton $w.f1.dyn_event -text "Dynamic Events" -variable sub_display_type -value 3 \
		-anchor w -command {
		global dyn_event_display_mode 
		set dyn_event_display_mode 0 
		coala_display_neg_dyn_event
	}
    coala_bind_help $w.f1.dyn_event "coala_shorthelp ana1_rb_dyn_event.hlp"

    pack $w.f1.dyn_event -in $w.f1 -fill x 
    # ===== start with display of coalition proposals 
	# ===== BSCA-T 
	if {[lindex $opt_sim 3] != 1 && [lindex $opt_sim 3] != 7} {
	    set sub_display_type 1
    	$w.f1.trust invoke
	} else {
	    set sub_display_type 2
    	$w.f1.proposal invoke
	} 
	focus $w
    update
}

proc coala_display_sub_item {} {
	global sub_display_type
	if {$sub_display_type == 1} {
		coala_display_neg_trust_relations
	} else {
		if {$sub_display_type == 2} {
			coala_display_neg_proposal
		} else {
			coala_display_neg_dyn_event
		}
	}
}

