# -----------------------------------------------------------------------------
# Copyright (c) 2009 by Christine Walter, Matthias Klusch
# Saarland University and German Research Center for Artificial Intelligence,
# Saarbruecken, Germany
#
# All rights reserved. No warranties will be given on any issues arising out 
# of the use of this software product. Permission to use, copy, modify and 
# distribute this software product for non-commercial purposes is hereby 
# granted, provided that the above copyright notice appears in all copies and 
# respective publications.
# All commercial trades with this product without specific written prior 
# permission are prohibited.
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbrcken, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------


# ===== coala_change_preset
# ===== This script opens a window for changing the values in preset 

proc coala_change_agent_preset {} {
	set w .change_agent_preset
	catch {
		destroy $w
	}
	
	toplevel $w
	wm title $w "Change Agent Preset"

	# ====== entry field for options 
	global opt_agent
	global preset_opt_agent preset_opt_info 



	# ===== frames
	frame $w.f1 -relief ridge -bd 2
	pack $w.f1 -side top -fill x -expand 1
	frame $w.f2 
	pack $w.f2 -side bottom -fill x


	# ====== frames in f2 (middle frame)
	frame $w.f11 -relief ridge -bd 2	
	frame $w.f12 -relief ridge -bd 2	
	frame $w.f13  -relief ridge -bd 2
	frame $w.f14  -relief ridge -bd 2
	frame $w.f_num_neg
	frame $w.f_latecomer 
	frame $w.f_dropout 
	frame $w.f_num_info
	frame $w.f_rel_begin 
	frame $w.f_irrel_dur 
	frame $w.f_rel_dur 
	frame $w.f_more_opt
	frame $w.f_prob_period
	frame $w.f_act_mal 
	frame $w.f_opp_opt
	frame $w.f_trick_rel 
	
	pack $w.f11 -fill x -side top  -in $w.f1	
	pack $w.f12 -fill x -side top  -in $w.f1
	pack $w.f13 -fill x -side top  -in $w.f1	
	pack $w.f14 -fill x -side top  -in $w.f1	
	pack $w.f_num_neg -fill x -side top -in $w.f11
	pack $w.f_latecomer -fill x -side top -in $w.f11
	pack $w.f_dropout -fill x -side top -in $w.f11
	pack $w.f_num_info -fill x -side top -in $w.f12
	pack $w.f_rel_begin -fill x -side top -in $w.f12
	pack $w.f_irrel_dur -fill x -side top -in $w.f12
	pack $w.f_rel_dur -fill x -side top -in $w.f12
	pack $w.f_more_opt -fill x -side top -in $w.f13
	pack $w.f_prob_period -fill x -side top -in $w.f13
	pack $w.f_act_mal -fill x -side top -in $w.f13
	pack $w.f_opp_opt -fill x -side top -in $w.f14 
	pack $w.f_trick_rel -fill x -side top -in $w.f14 

	# ====== entry field for options 
	global opt_agent
	global preset_opt_agent preset_opt_info 


	# ====== options about participating
	label $w.l_num_neg -text "Number of Negotiations to..."
	pack $w.l_num_neg -side top -fill both -in $w.f_num_neg

	# ====== option: participating as a latecomer
	global text_latecomer
	set text_latecomer "Participate in as a Latecomer :"
	label $w.l_latecomer -textvariable text_latecomer
	entry $w.e_latecomer -width 4 
	pack $w.l_latecomer -side left -fill y -in $w.f_latecomer
	pack $w.e_latecomer -side right -fill y -in $w.f_latecomer	
	$w.e_latecomer insert 0 [lindex $preset_opt_agent 0]
	coala_bind_help $w.l_latecomer "coala_shorthelp agent_preset_latecomer.hlp"
	coala_bind_help $w.e_latecomer "coala_shorthelp agent_preset_latecomer.hlp"

	# ====== option: drop out of negotiation
	global text_dropout
	set text_dropout "Drop Out before the End :"
	label $w.l_dropout -textvariable text_dropout
	entry $w.e_dropout -width 4 
	pack $w.l_dropout -side left -fill y -in $w.f_dropout
	pack $w.e_dropout -side right -fill y -in $w.f_dropout	
	$w.e_dropout insert 0 [lindex $preset_opt_agent 1]
	coala_bind_help $w.l_dropout "coala_shorthelp agent_preset_dropout.hlp"
	coala_bind_help $w.e_dropout "coala_shorthelp agent_preset_dropout.hlp"

	# ====== options about Information-Units
	label $w.l_num_info -text "Number of Info-Units..."
	pack $w.l_num_info -side top -fill both -in $w.f_num_info

	# ====== option: relevant from the beginning
	global text_rel_begin
	set text_rel_begin "Relevant at the Start of each Negotiation :"
	label $w.l_rel_begin -textvariable text_rel_begin
 	entry $w.e_rel_begin -width 4 
	pack $w.l_rel_begin -side left -fill y -in $w.f_rel_begin
	pack $w.e_rel_begin -side right -fill y -in $w.f_rel_begin	
	$w.e_rel_begin insert 0 [lindex $preset_opt_agent 2]
	coala_bind_help $w.l_rel_begin "coala_shorthelp agent_preset_startrel.hlp"
	coala_bind_help $w.e_rel_begin "coala_shorthelp agent_preset_startrel.hlp"

	# ====== option: becoming irrelevant during the negotiation
	global text_irrel_dur
	set text_irrel_dur "Becoming Irrelevant during each Negotiation :"
	label $w.l_irrel_dur -textvariable text_irrel_dur
 	entry $w.e_irrel_dur -width 4 
	pack $w.l_irrel_dur -side left -fill y -in $w.f_irrel_dur
	pack $w.e_irrel_dur -side right -fill y -in $w.f_irrel_dur	
	$w.e_irrel_dur insert 0 [lindex $preset_opt_agent 3]
	coala_bind_help $w.l_irrel_dur "coala_shorthelp agent_preset_durirrel.hlp"
	coala_bind_help $w.e_irrel_dur "coala_shorthelp agent_preset_durirrel.hlp"

	# ====== option: becoming relevant during a negotiation
	global text_rel_dur
	set text_rel_dur "Becoming Relevant during each Negotiation :"
	label $w.l_rel_dur -textvariable text_rel_dur
 	entry $w.e_rel_dur -width 4 
	pack $w.l_rel_dur -side left -fill y -in $w.f_rel_dur
	pack $w.e_rel_dur -side right -fill y -in $w.f_rel_dur	
	$w.e_rel_dur insert 0 [lindex $preset_opt_agent 4]
	coala_bind_help $w.l_rel_dur "coala_shorthelp agent_preset_durrel.hlp"
	coala_bind_help $w.e_rel_dur "coala_shorthelp agent_preset_durrel.hlp"

	label $w.l_more_opt -text "More Options for Behaviour"
	pack $w.l_more_opt -side top -fill both -in $w.f_more_opt

	# ====== option: becoming relevant during a negotiation
	label $w.l_prob_period -text "Probation Period :"
 	entry $w.e_prob_period -width 4 
	pack $w.l_prob_period -side left -fill y -in $w.f_prob_period
	pack $w.e_prob_period -side right -fill y -in $w.f_prob_period	
	$w.e_prob_period insert 0 [lindex $preset_opt_agent 5]
	coala_bind_help $w.l_prob_period "coala_shorthelp agent_preset_prob.hlp"
	coala_bind_help $w.e_prob_period "coala_shorthelp agent_preset_prob.hlp"

	global act_malicious  
	set act_malicious [lindex $preset_opt_agent 6]
	checkbutton $w.c_act_mal -text "Acts Maliciously" -variable act_malicious -anchor w 
	pack $w.c_act_mal -side left -fill y -in $w.f_act_mal	
	coala_bind_help $w.c_act_mal "coala_shorthelp agent_preset_malicious.hlp"

	global text_trick_rel 
	global is_opportunist  
	set is_opportunist [lindex $preset_opt_agent 7]
	checkbutton $w.c_opp_ag -text "Is Opportunist" -variable is_opportunist -anchor w -command {if {$is_opportunist} {} else {set trick_rel 0}}
	pack $w.c_opp_ag -fill y -in $w.f_act_mal	 

	label $w.l_opp_opt -text "Options For Opportunistic Agents Only"
	pack $w.l_opp_opt -side top -fill both -in $w.f_opp_opt

	set text_trick_rel "Information Units Pretended to Be of Interest :" 
	label $w.l_trick_rel -textvariable text_trick_rel 
	entry $w.e_trick_rel -width 4  -textvariable trick_rel
	pack $w.l_trick_rel -side left -fill y -in $w.f_trick_rel 
	pack $w.e_trick_rel -side right -fill y -in $w.f_trick_rel	 
	$w.e_trick_rel insert 0 [lindex $preset_opt_agent 8]


	# ===== Command Buttons
	button $w.ok -text "OK" -command {
		set val [.change_agent_preset.e_latecomer get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Participate in as a Latecomer!"
			return 
		}
		
		set val [.change_agent_preset.e_dropout get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Drop Out before the End!"
			return 
		}
		
		
		set val [.change_agent_preset.e_rel_begin get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Relevant at the Start of each Negotiation!"
			return
		}
		
		set val [.change_agent_preset.e_irrel_dur get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Becoming Irrelevant during each Negotiation!"
			return
		}
		
		set val [.change_agent_preset.e_rel_dur get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Becoming Relevant during each Negotiation!"
			return 
		}
		
		set val [.change_agent_preset.e_prob_period get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Probation Period!"
			return 
		}
		
		set preset_opt_agent {}
		lappend preset_opt_agent [.change_agent_preset.e_latecomer get]
		lappend preset_opt_agent [.change_agent_preset.e_dropout get]
		lappend preset_opt_agent [.change_agent_preset.e_rel_begin get]
		lappend preset_opt_agent [.change_agent_preset.e_irrel_dur get]
		lappend preset_opt_agent [.change_agent_preset.e_rel_dur get]
		lappend preset_opt_agent [.change_agent_preset.e_prob_period get]
		lappend preset_opt_agent $act_malicious
		lappend preset_opt_agent $is_opportunist
		lappend preset_opt_agent [.change_agent_preset.e_trick_rel get]
		# ===== write preset file
		set file [open "coala_preset" w]
		puts $file $preset_opt_info
		puts $file $preset_opt_agent
		close $file
		
		# ===== close window
		destroy .change_agent_preset
	}

	button $w.cancel -text "Cancel" -command {
		# ===== close window
		destroy .change_agent_preset
	}

	bind $w <Return> "$w.ok invoke"
	bind $w <Escape> "$w.cancel flash; $w.cancel invoke"

	pack $w.ok -side left -in $w.f2
	pack $w.cancel -side right -in $w.f2
	coala_bind_help $w.ok "coala_shorthelp agent_preset_ok.hlp"
	coala_bind_help $w.cancel "coala_shorthelp agent_preset_cancel.hlp"

	# ===== grab focus
	focus $w
	focus $w.e_latecomer
	update
	grab $w
  
	tkwait window $w
}



