# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbrcken, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ===== coala_change_infounit_preset
# ===== This script opens a window for changing the values in preset 

proc coala_change_infounit_preset {} {
	set w .change_info_preset
	catch {
		destroy $w
	}
	
	toplevel $w
	wm title $w "Change Info-Unit Preset"

	# ====== frames
	frame $w.f0 -relief ridge -bd 2
	frame $w.f1 
	frame $w.f2 
	frame $w.f3
	frame $w.f4
	frame $w.f5

	pack $w.f0 -fill x -side top 
	pack $w.f1 -fill x -side top -in $w.f0
	pack $w.f2 -fill x -side top -in $w.f0
	pack $w.f3 -fill x -side top -in $w.f0
	pack $w.f4 -fill x -side top -in $w.f0
	pack $w.f5 -fill x -side bottom

	global preset_opt_info preset_opt_sim preset_opt_agent
	# ====== option : Number of Default Info-Unit for Each Agent
	label $w.l1 -text "Number of Default Info-Units for Each Agent :"
	entry $w.e1 -width 4 
	pack $w.l1 -side left -fill y -in $w.f1
	pack $w.e1 -side right -fill y -in $w.f1	
	$w.e1 insert 0 [lindex $preset_opt_info 0]
        coala_bind_help $w.l1 "coala_shorthelp info_unit_preset.hlp"
        coala_bind_help $w.e1 "coala_shorthelp info_unit_preset.hlp"



	# ====== option : Price of each Default Info-Unit 
	label $w.l2 -text "Price of Each Default Info-Unit :"
	entry $w.e2 -width 4  
	pack $w.l2 -side left -fill y -in $w.f2
	pack $w.e2 -side right -fill y -in $w.f2
	$w.e2 insert 0 [lindex $preset_opt_info 1]
        coala_bind_help $w.l2 "coala_shorthelp info_unit_preset.hlp"
        coala_bind_help $w.e2 "coala_shorthelp info_unit_preset.hlp"

	# ====== option : Accessible by 
	label $w.l3 -text "----------------"
	label $w.l4 -text "Accessible By"
	pack $w.l3 -side top -fill x -in $w.f3
	pack $w.l4 -side top -fill x -in $w.f3
	global preset_access
	set preset_access [lindex $preset_opt_info 2]
	radiobutton $w.r1 -text "All Other Agents    " -variable preset_access -value 1 -anchor w 
	radiobutton $w.r2 -text "None        " -variable preset_access -value 2 -anchor w 
	pack $w.r1 -in $w.f3 -fill y -side left
	pack $w.r2 -in $w.f3 -fill y -side right
        coala_bind_help $w.r1 "coala_shorthelp info_unit_preset.hlp"
        coala_bind_help $w.r2 "coala_shorthelp info_unit_preset.hlp"

	button $w.ok -text "OK" -command {
		set val [.change_info_preset.e1 get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Number of Default Info-Units for Each Agent!"
			return 
		}

		set val [.change_info_preset.e2 get]
		if {![coala_int $val]} {
			coala_message "Error" "Please insert an Integer for Price of Each Default Info-Unit!"
			return 
		}

		set preset_opt_info {}
		set preset_opt_info [list [.change_info_preset.e1 get ] [.change_info_preset.e2 get ] $preset_access]
		# ===== write preset file
		set file [open "coala_preset" w]
		puts $file $preset_opt_info
		puts $file $preset_opt_agent
		close $file
		# ===== close window
		destroy .change_info_preset
	}

	button $w.cancel -text "Cancel" -command {
		# ===== close window
		destroy .change_info_preset
	}

	bind $w <Return> "$w.ok invoke"
	bind $w <Escape> "$w.cancel flash; $w.cancel invoke"

	pack $w.ok -side left -in $w.f5
	pack $w.cancel -side right -in $w.f5
        coala_bind_help $w.ok "coala_shorthelp info_unit_preset.hlp"
        coala_bind_help $w.ok "coala_shorthelp info_unit_preset.hlp"

	# ===== grab focus
	focus $w
	focus $w.e1
	update
	grab $w
  
	tkwait window $w

}
