# -----------------------------------------------------------------------------$)C
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-A|cken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

proc coala_display_neg_trust_relations {} {
    global c_font

    set w .analyze
    destroy $w.f2

    # ===== make "new" special frame
    frame $w.f2  -relief ridge -bd 2
    pack $w.f2 -side top -fill x -in $w.right

    frame $w.f2.f1
    pack $w.f2.f1 -in $w.f2 -fill x -side top
    label $w.f2.l1 -text "Select a Coalition"
	coala_bind_help $w.f2.l1 "coala_shorthelp ana1_lb_trust_relation.hlp"
    pack $w.f2.l1 -in $w.f2.f1 -side top -fill x

    frame $w.f2.f2
    pack $w.f2.f2 -in $w.f2 -fill x -side top
    scrollbar $w.f2.scroll1 -command "$w.f2.c_list yview"
    listbox $w.f2.c_list -yscroll "$w.f2.scroll1 set" \
		-relief raised -exportselection no -height 10 -width 16  
	coala_bind_help $w.f2.c_list "coala_shorthelp ana1_lb_trust_relation.hlp"
    pack $w.f2.c_list -side left -fill both -expand 1 -in $w.f2.f2
    pack $w.f2.scroll1 -side right -fill y -in $w.f2.f2

	bind $w.f2.c_list <ButtonRelease-1> {
		global rnd_coal_struct round_num trust_relation
		set coal_num [.analyze.f2.c_list curselection] 
		set sel_coal [lindex $rnd_coal_struct $coal_num]
		coala_delete_trust_relation_line
		coala_draw_trust_relation_line trust_relation $sel_coal $rnd_coal_struct
	}
	coala_correct_round_num

	global round_num simulation_name selected_neg max_round
	global a_agents rnd_coal_struct 
	set logfile [open "logs/$simulation_name\.$selected_neg\.log" r]
	gets $logfile line
	set a_agents [lreplace $line 0 0]
	gets $logfile line
	set rnd_coal_struct [lreplace $line 0 0]
	# ===== read result of last round (i.e. the formation of at the beginning of the round)
	while {![eof $logfile]} {
   		gets $logfile line
		if {[lindex $line 0] == "round"} {
			if {[lindex $line 1] == [expr $round_num - 1]} {
				while {![eof $logfile]} {
			   		gets $logfile line
					if {[lindex $line 0] != "ragents"} {
						continue
					}
					set a_agents [lreplace $line 0 0]
					gets $logfile line
					set rnd_coal_struct [lreplace $line 0 0]
					break
				}
				break
			} else {
				if {[lindex $line 1] > [expr $round_num - 1]} {
					break
				}
			}
		}
	}

	global trust_relation
	if [info exists trust_relation] {
		unset trust_relation
	}
	# ===== read trust relations
	while {![eof $logfile]} {
   		gets $logfile line
		if {[lindex $line 0] == "trust_relations"} {
			while {![eof $logfile]} {
		   		gets $logfile line
				if {[lindex $line 0] == "end_trust_relations"} {
					break
				}
				set agent [lindex $line 0]
				set trust_relation($agent) [lreplace $line 0 0]
			} 
			break
		}
	}
	close $logfile


	# ===== set array indexed with representant
	global repr_for
	catch {
		unset repr_for
	}
	foreach coal $rnd_coal_struct {
		set repr_for([lindex $coal 0]) $coal
	}

    foreach coal $rnd_coal_struct {
		$w.f2.c_list insert end $coal
    }
    # ===== adjust widths
    coala_check_list $w.f2.c_list 16
	# ===== select the first agent 
	$w.f2.c_list selection set 0
	coala_paint_trust_relations [lindex $rnd_coal_struct 0]
}



# ===== paints trust relations for one round
proc coala_paint_trust_relations {coalition} {
	global rnd_coal_struct a_agents
	global agent_xpos agent_ypos 

	# ===== sizes for agents, ....
	set agent_width 100
	set agent_height 50
    
	set pi 3.1415927
	set radius [expr int([llength $a_agents] / 4.0 * $agent_height * 2.5)]
	set center_x [expr 40 + $radius]
	set center_y [expr 40 + $radius]
	set angle_per_agent [expr 2 * $pi / [llength $a_agents]]

	set i 0
	foreach agent $a_agents {
	    set agent_xpos($agent) [expr int(cos([expr 3.1415927+$angle_per_agent*$i])*$radius)+$center_x]
	    set agent_ypos($agent) [expr int(sin([expr 3.1415927+$angle_per_agent*$i])*$radius)+$center_y]
		incr i 1
	}

	global repr_for mpressed ids_for_coal 
	global connections max_round a_agents c_font coal_partners agent_partners
	if [info exists ids_for_coal] {
		unset ids_for_coal
	}

	global info_for_detail
	if [info exists info_for_detail] {
		unset info_for_detail
	}

	global ids_for_subwindow
	if [info exists ids_for_subwindow] {
		unset ids_for_subwindow
	}

	set mpressed 0
    
	set w .analyze

	# ===== clear canvas
	eval .analyze.canvas delete [.analyze.canvas find all]

	global round_num selected_neg
	# ===== title for the canvas
	.analyze.canvas create text 10 10 -text "Trust Relations at Round $round_num of Negotiation $selected_neg" \
		-anchor w -font $c_font
    coala_bind_help .analyze.canvas "coala_shorthelp ana1_dg_trust_relation.hlp"
	coala_display_color_explanation_for_trust_relation

	# ===== clear connections list 
	catch {
		unset connections
	}

	# ===== paint coalitions
	foreach coal $rnd_coal_struct {
		set agent [lindex $coal 0]
		set xpos $agent_xpos($agent)
		set ypos $agent_ypos($agent)
		set repr_agent $agent
	
		foreach agent $coal {
			set id [$w.canvas create rectangle $xpos $ypos [expr $xpos + $agent_width] [expr $ypos + $agent_height] -fill white]
			lappend ids_for_coal($coal) $id

			# ===== bind mouse button (for dragging the coalitions)
			$w.canvas bind $id <Button-1>  "global mpressed, sel_coal; set mpressed 1; set sel_coal [list $coal]"
			$w.canvas bind $id <ButtonRelease-1> {
				global mpressed sel_coal
				if {$mpressed} {
					global repr_for agent_xpos agent_ypos sel_round rnd_coal_struct

					# ===== get representative for the selected coalition
					set agent [lindex $sel_coal 0]
					set xpos $agent_xpos($agent)
					set ypos $agent_ypos($agent)
		
					# ===== delete the relation lines (for case click without motion)
					global connections
					set array_name_list [concat [array names connections "$agent,*"] [array names connections "*,$agent"]] 
					foreach ag_pair $array_name_list {
						foreach id $connections($ag_pair) {
							.analyze.canvas delete $id
						}
						set connections($ag_pair) {}
					}
					global ids_for_subwindow
					foreach main_id [array names ids_for_subwindow] {
						foreach id $ids_for_subwindow($main_id) {
							.analyze.canvas delete $id
						}
						set $ids_for_subwindow($main_id) {}
					}

					global trust_relation
					set coal_num [.analyze.f2.c_list curselection] 
					set src_coal [lindex $rnd_coal_struct $coal_num]
					coala_draw_trust_relation_line trust_relation $src_coal $rnd_coal_struct
					# ===== adjust scrollregion
					coala_adjust_analyze_canvas								
				}
				set mpressed 0
			}

			$w.canvas bind $id <Motion> {
				global mpressed sel_coal
		
				# ====== mouse move and a coalition is selected
				if {$mpressed} { 
					global repr_for agent_xpos agent_ypos 

					# ===== get representative for the selected coalition
					set agent [lindex $sel_coal 0]
					set xpos $agent_xpos($agent)
					set ypos $agent_ypos($agent)
			  
					# ===== move every widget that belongs to the selected coalition
					global ids_for_coal
					foreach id $ids_for_coal($sel_coal) {
						.analyze.canvas move $id [expr [.analyze.canvas canvasx %x] - $xpos] [expr [.analyze.canvas canvasy %y] - $ypos] 
					}

					# ===== remember new position
					set agent_xpos($agent) [expr int([.analyze.canvas canvasx %x])]		  
					set agent_ypos($agent) [expr int([.analyze.canvas canvasy %y])]

					# ===== delete the relation lines 
					global connections
					set array_name_list [concat [array names connections "$agent,*"] [array names connections "*,$agent"]] 
					foreach ag_pair $array_name_list {
						foreach id $connections($ag_pair) {
							.analyze.canvas delete $id
						}
						set connections($ag_pair) {}
					}
					global ids_for_subwindow
					foreach main_id [array names ids_for_subwindow] {
						foreach id $ids_for_subwindow($main_id) {
							.analyze.canvas delete $id
						}
						set $ids_for_subwindow($main_id) {}
					}
					# ===== adjust scrollregion
					coala_adjust_analyze_canvas
				} 
			}
			# ===== write the name of the agent into it
			set id [$w.canvas create text [expr $xpos + ($agent_width /2)] [expr $ypos + 15] -text $agent \
				-anchor c -justify center -font $c_font]
			lappend ids_for_coal($coal) $id
			incr xpos $agent_width
		}
	}
	global trust_relation
	coala_draw_trust_relation_line trust_relation $coalition $rnd_coal_struct 
	# ===== find bounding box for all items in the canvas
	set xmin 100000
	set ymin 100000
	set xmax -100000
	set ymax -100000
    
	foreach id [.analyze.canvas find all] {
		if {[lindex [.analyze.canvas coords $id] 0] < $xmin} {
			set xmin [lindex [.analyze.canvas coords $id] 0]
		}		   
		if {[lindex [.analyze.canvas coords $id] 0] > $xmax} {
			set xmax [lindex [.analyze.canvas coords $id] 0]
		}
		if {[lindex [.analyze.canvas coords $id] 1] < $ymin} {
			set ymin [lindex [.analyze.canvas coords $id] 1]
		}
		if {[lindex [.analyze.canvas coords $id] 1] > $ymax} {
			set ymax [lindex [.analyze.canvas coords $id] 1]
		}
	}
    
	# ===== margins
	set ymax [expr $ymax + 30]

	# ===== adjust scrollregion
	coala_adjust_analyze_canvas
}


proc coala_draw_trust_relation_line {ref_trust_relation src_coal coal_struct} {
	upvar $ref_trust_relation trust_relation
	global connections

	set repr_agent [lindex $src_coal 0]
	set classified_coals [coala_get_trust_classified_coalitions $src_coal trust_relation $coal_struct]
	set i 0
	foreach coal_with_trustgrade $classified_coals {
		set dest_coal [lindex $coal_with_trustgrade 0] 
		# ===== reprasentant of destination coalition
		set dest_agent [lindex $dest_coal 0]
		# ===== create line with arrow
		set coords [coala_get_shortest_connection $dest_agent $repr_agent]
		set grade [lindex $coal_with_trustgrade 1]
		if {$grade == 0} {
			set sel_color blue
		} else {
			if {$grade == 1} {
				set sel_color black
			} else {
				set sel_color red
			}
		}
		set id [eval .analyze.canvas create line $coords -width 2 -arrow last -fill $sel_color]
		lappend connections($repr_agent,$dest_agent) $id
		global info_for_detail
		set info_for_detail($id) [list $src_coal $dest_coal $i $coords] 
		incr i
		if {[llength $src_coal] == 1 && [llength $dest_coal] == 1} {
			continue
		}
		if {[llength $src_coal] == 1 || [llength $dest_coal] == 1} {
			.analyze.canvas bind $id <Button-1> {
				set item_id [.analyze.canvas find withtag current]
				global info_for_detail
				coala_draw_trust_relation_agent_vs_agent $info_for_detail($item_id)
			}
		} else {
			.analyze.canvas bind $id <Button-1> {
				set item_id [.analyze.canvas find withtag current]
				global info_for_detail
				coala_draw_trust_relation_agent_vs_coalition $info_for_detail($item_id)				
			}
		} 
	}
}

proc coala_draw_trust_relation_agent_vs_agent {info_for_details} {	
	set src_coal [lindex $info_for_details 0]
	set dest_coal [lindex $info_for_details 1]
	# ===== read trust value
	# ===== read trust rating by others to 's_agent' 
	global selected_neg simulation_name
	foreach agent $src_coal {
		foreach dagent $dest_coal {
			set logfile [open "logs/$simulation_name\.trust$agent\.log" r]
			while {![eof $logfile]} {
				gets $logfile line
				if {$dagent != [lindex $line 0]} {
					continue
				}
				set trust_list [lreplace $line 0 0]
				break
			}
			close $logfile
			
			foreach trust $trust_list {
				if {$trust == ""} {
					break
				}
				if {$selected_neg != [lindex $trust 0]} {
					continue
				} 
				if {[lindex $trust 1] < 0} {
					set color([list $agent $dagent]) red
				} else {
					set color([list $agent $dagent]) blue
				}
				break
			}
		}
	}

	set dest_coal_id [lindex $info_for_details 2]
	set coords [lindex $info_for_details 3]
	set center_x  [expr ([lindex $coords 0] + [lindex $coords 2]) / 2]
	set center_y  [expr ([lindex $coords 1] + [lindex $coords 3]) / 2]
	# ===== sizes for agents, ....
	set agent_width 80
	set agent_height 40
    
	# ==== coalition position
	set src_coal_xpos [expr $center_x - int(([llength $src_coal] / 2.0) * $agent_width)]
	set src_coal_ypos [expr $center_y + $agent_height]
	set dest_coal_xpos [expr $center_x - int(([llength $dest_coal] / 2.0) * $agent_width)]
	set dest_coal_ypos [expr $center_y - $agent_height]
	# ==== rectangle position
	set rec_xpos [expr [expr {$src_coal_xpos < $dest_coal_xpos ? $src_coal_xpos : $dest_coal_xpos}] - ($agent_width / 2)]
	set rec_ypos [expr $dest_coal_ypos - $agent_height]
	set i 0
	set offset [expr (1 + [expr {$src_coal_xpos < $dest_coal_xpos ? [llength $src_coal] : [llength $dest_coal]}]) * $agent_width]
	set rec_xpos_end [expr $rec_xpos + $offset]
	set rec_ypos_end [expr $rec_ypos + int($agent_height * 4.5)]
	
	set i 0 
	foreach agent $src_coal {
	    set xpos($agent) [expr $src_coal_xpos + $i * $agent_width]
	    set ypos($agent) $src_coal_ypos
		incr i 1
	}
	set i 0 
	foreach agent $dest_coal {
	    set xpos($agent) [expr $dest_coal_xpos + $i * $agent_width]
	    set ypos($agent) $dest_coal_ypos
		incr i 1
	}
	global ids_for_subwindow c_font
	# ==== draw rectangle
	set rgb [format "#%02x%02x%02x"  95 158 160]
	set main_id [.analyze.canvas create rectangle $rec_xpos $rec_ypos $rec_xpos_end $rec_ypos_end -fill $rgb]
	set ids_for_subwindow($main_id) {}
	.analyze.canvas bind $main_id <Button-1> {
		set item_id [.analyze.canvas find withtag current]
		global ids_for_subwindow
		foreach id $ids_for_subwindow($item_id) {
			.analyze.canvas delete $id
		}
	}
				 
	lappend ids_for_subwindow($main_id) $main_id
	set id [.analyze.canvas create text [expr $rec_xpos + $offset / 2] [expr $rec_ypos + 10] \
			 -text "Trust Relation (Agent vs. Agent)" -anchor c -justify center -font $c_font]
	lappend ids_for_subwindow($main_id) $id
	# ==== draw agent box
	foreach agent [concat $src_coal $dest_coal] { 
		 set id [.analyze.canvas create rectangle $xpos($agent) $ypos($agent) [expr $xpos($agent) + $agent_width] \
					 [expr $ypos($agent) + $agent_height] -fill white]
		 lappend ids_for_subwindow($main_id) $id
		 set id [.analyze.canvas create text [expr $xpos($agent) + ($agent_width / 2)] [expr $ypos($agent) + ($agent_height / 2)] \
					 -text $agent -anchor c -justify center -font $c_font]
		 lappend ids_for_subwindow($main_id) $id
	}
	# ==== draw arrows
	foreach agent $src_coal {
		foreach dagent $dest_coal {
			set id [eval .analyze.canvas create line [expr $xpos($agent) + $agent_width / 2] $ypos($agent) \
						[expr $xpos($dagent) + $agent_width / 2] [expr $ypos($dagent) + $agent_height] -width 2 \
						-arrow first -fill $color([list $agent $dagent])] 
			lappend ids_for_subwindow($main_id) $id
		}
	}
	# ===== adjust scrollregion
	coala_adjust_analyze_canvas
}


proc coala_draw_trust_relation_agent_vs_coalition {info_for_details} {
	set src_coal [lindex $info_for_details 0]
	set dest_coal [lindex $info_for_details 1]
	set dest_coal_id [lindex $info_for_details 2]
	# ===== read trust value
	# ===== read trust rating by others to 's_agent' 
	global trust_relation
	set dagent [lindex $dest_coal 0]
	foreach agent $src_coal {
		if {[lindex $trust_relation($agent) $dest_coal_id] == 0} {
			set color([list $agent $dagent]) blue
		} else {
			if {[lindex $trust_relation($agent) $dest_coal_id] == 1} {
				set color([list $agent $dagent]) black
			} else {
				set color([list $agent $dagent]) red
			}
		}
	}

	set coords [lindex $info_for_details 3]
	set center_x  [expr ([lindex $coords 0] + [lindex $coords 2]) / 2]
	set center_y  [expr ([lindex $coords 1] + [lindex $coords 3]) / 2]
	# ===== sizes for agents, ....
	set agent_width 80
	set agent_height 40
    
	# ==== coalition position
	set src_coal_xpos [expr $center_x - int(([llength $src_coal] / 2.0) * $agent_width)]
	set src_coal_ypos [expr $center_y + $agent_height]
	set dest_coal_xpos [expr $center_x - int(([llength $dest_coal] / 2.0) * $agent_width)]
	set dest_coal_ypos [expr $center_y - $agent_height]
	# ==== rectangle position
	set rec_xpos [expr [expr {$src_coal_xpos < $dest_coal_xpos ? $src_coal_xpos : $dest_coal_xpos}] - ($agent_width / 2)]
	set rec_ypos [expr $dest_coal_ypos - $agent_height]
	set i 0
	set offset [expr (1 + [expr {$src_coal_xpos < $dest_coal_xpos ? [llength $src_coal] : [llength $dest_coal]}]) * $agent_width]
	set rec_xpos_end [expr $rec_xpos + $offset]
	set rec_ypos_end [expr $rec_ypos + int($agent_height * 4.5)]
	
	set i 0 
	foreach agent $src_coal {
	    set xpos($agent) [expr $src_coal_xpos + $i * $agent_width]
	    set ypos($agent) $src_coal_ypos
		incr i 1
	}
	set i 0 
	foreach agent $dest_coal {
	    set xpos($agent) [expr $dest_coal_xpos + $i * $agent_width]
	    set ypos($agent) $dest_coal_ypos
		incr i 1
	}
	global ids_for_subwindow c_font
	# ==== draw rectangle
	set rgb [format "%02x%02x%02x"  95 158 160]
	set main_id [.analyze.canvas create rectangle $rec_xpos $rec_ypos $rec_xpos_end $rec_ypos_end -fill #$rgb]
	set ids_for_subwindow($main_id) {}
	.analyze.canvas bind $main_id <Button-1> {
		set item_id [.analyze.canvas find withtag current]
		global ids_for_subwindow
		foreach id $ids_for_subwindow($item_id) {
			.analyze.canvas delete $id
		}
	}				 
	lappend ids_for_subwindow($main_id) $main_id
	set id [.analyze.canvas create text [expr $rec_xpos + $offset / 2] [expr $rec_ypos + 10] \
			 -text "Trust Relation (Coalition vs. Agent)" -anchor c -justify center -font $c_font]
	lappend ids_for_subwindow($main_id) $id
	# ==== draw agent box
	foreach agent [concat $src_coal $dest_coal] { 
		 set id [.analyze.canvas create rectangle $xpos($agent) $ypos($agent) [expr $xpos($agent) + $agent_width] \
					 [expr $ypos($agent) + $agent_height] -fill white]
		 lappend ids_for_subwindow($main_id) $id
		 set id [.analyze.canvas create text [expr $xpos($agent) + ($agent_width / 2)] [expr $ypos($agent) + ($agent_height / 2)] \
					 -text $agent -anchor c -justify center -font $c_font]
		 lappend ids_for_subwindow($main_id) $id
	}
	# ==== draw arrows
	global info_for_detail
	foreach agent $src_coal {
		set coords [list [expr $xpos($agent) + $agent_width / 2] $ypos($agent) $center_x [expr $dest_coal_ypos + $agent_height]]
		set id [eval .analyze.canvas create line $coords -width 2 -arrow first -fill $color([list $agent $dagent])] 
		set info_for_detail($id) [list $agent $dest_coal $dest_coal_id $coords]
		.analyze.canvas bind $id <Button-1> {
			set item_id [.analyze.canvas find withtag current]
			global info_for_detail
			coala_draw_trust_relation_agent_vs_agent $info_for_detail($item_id)
		}
		lappend ids_for_subwindow($main_id) $id
	}
	# ===== adjust scrollregion
	coala_adjust_analyze_canvas	
}

proc coala_delete_trust_relation_line {} {
	global connections
	foreach coal_pair [array names connections] {
		foreach id $connections($coal_pair) {
			.analyze.canvas delete $id
		}
		set connections($coal_pair) {}
	}
	global ids_for_subwindow
	foreach main_id [array names ids_for_subwindow] {
		foreach id $ids_for_subwindow($main_id) {
			.analyze.canvas delete $id
		}
		set $ids_for_subwindow($main_id) {}
	}
}

proc coala_correct_round_num {} {
	global round_num simulation_name selected_neg max_round

	set max_round 0
	set logfile [open "logs/$simulation_name\.$selected_neg\.log" r]
	# ===== read formation after each round
	while {![eof $logfile]} {
   		gets $logfile line
		if {[lindex $line 0] == "round"} {
			incr max_round
		}
	}
	close $logfile
	if {$round_num > $max_round} {
		set round_num $max_round
	}
}

proc coala_display_color_explanation_for_trust_relation {} {
	global round_num c_font

	set g_colors {blue black red}
	set dyn_text(0) ": Coalition A is trustworthy for Coalition B"
	set dyn_text(1) ": Coalition A is neutral for Coalition B"
	set dyn_text(2) ": Coalition A is untrustworthy for Coalition B"

	set from_x 460
	set from_y 5
#    .analyze.canvas create text $expl_from_x 5 -text "Color Explanation" -font $c_font -anchor nw
	for {set i 0} {$i < 3} {incr i} {
	    .analyze.canvas create text $from_x [expr $i * 20 + $from_y + 2] -text A -font $c_font -anchor nw
		.analyze.canvas create line [expr $from_x + 10] [expr $from_y + $i * 20 + 10] [expr $from_x + 30] \
				[expr $from_y + $i * 20 + 10] -arrow last -width 2 -fill [lindex $g_colors $i]
	    .analyze.canvas create text [expr $from_x + 30] [expr $i * 20 + $from_y + 2] -text B -font $c_font -anchor nw
	    .analyze.canvas create text [expr $from_x + 45] [expr $i * 20 + $from_y + 2] -text $dyn_text($i) \
			-font $c_font -anchor nw
	}
}
