
proc  coala_display_no_coal_offers {} {
	global c_font
	global agents_list act_mal is_opp
	global simulation_name opt_sim
	
	set w .analyze
	destroy $w.f1


	# ===== clear canvas
	eval .analyze.canvas delete [.analyze.canvas find all]
	.analyze.canvas create text 10 30 -text "Number of coalitions made by agents (and number of offers received):" -font $c_font -anchor nw

# line distance, init y val, column agents, column values
	set ld 15
	set y 60
	set xa 50
	set xv 160

# make vip list {agent #vip} for all agents
	foreach agent $agents_list {
		set vip($agent) 0
	}

# opt_sim works if sim loaded, test if var exists when sim just run, too
	set total_negs [lindex $opt_sim 0]
	for {set i 1} {$i <= $total_negs} {incr i} {
		set logfile [open "logs/$simulation_name\.$i\.log" r]
		while {![eof $logfile]} {
			gets $logfile line
			if {[lindex $line 0] == "rcoalitions"} {
				set final_coal_struct [lreplace $line 0 0]
			}
		}
		close $logfile
# to count as vip coal, it must include at least half of all agents
#		set coal_size [expr [llength $agents_list] / 2]
		set coal_size 0
		set vips {}
		foreach coal $final_coal_struct {
			if {[llength $coal] > $coal_size} {
				set coal_size [llength $coal]
				set vips $coal
			} else {
				if {[llength $coal] == $coal_size} {
					set vips [concat $vips $coal]
				}
			}
		}
		foreach agent $vips {
			incr vip($agent)
		}
	}
#	for each neg logfile (i = 0-#negs)
#	get last rcoalitions line
#	find largest coal(s)
#	remember size and members
#	incr count for each member

	set stat_logfile [open "logs/$simulation_name\.stat.log" r]
	gets $stat_logfile line
	set list_all {}
	while {![eof $stat_logfile]} {
		gets $stat_logfile line
		if {$line == ""} {
			continue
		}
		set agent_name [lindex $line 0]
		set offers_received($agent_name) [lindex $line 10]
		set coals_made($agent_name) [lindex $line 11]
# search VIP list for agent's entry and set vip [lindex $entry 1]
		lappend list_all [list $coals_made($agent_name) $offers_received($agent_name) $agent_name $vip($agent)]
	}
	close $stat_logfile

	proc sort_list_all {j i} {
		if {[lindex $i 0] < [lindex $j 0]} {
        		return -1
	        } else {
        		if {[lindex $i 0] > [lindex $j 0]} {
                		return 1
            		} else {
				if {[lindex $i 1] <= [lindex $j 1]} {
					return -1
				} else {
					return 1
				}
			}
		}
	}

	set list_all [lsort -command sort_list_all $list_all]

	foreach entry $list_all {
		set agent [lindex $entry 2]
		if $is_opp($agent) {
			if $act_mal($agent) {
				.analyze.canvas create text $xa $y -text "$agent (opp, mal) :" -font $c_font -anchor nw 
			} else {
				.analyze.canvas create text $xa $y -text "$agent (opp) :" -font $c_font -anchor nw 
			}
		} else {
			if $act_mal($agent) {
				.analyze.canvas create text $xa $y -text "$agent (mal) :" -font $c_font -anchor nw 
			} else {
				.analyze.canvas create text $xa $y -text "$agent :" -font $c_font -anchor nw 
			}
		}
		.analyze.canvas create text $xv $y -text "$coals_made($agent) ($offers_received($agent)) - VIP in $vip($agent) negotiations" -font $c_font -anchor nw 
		set y [expr $y + $ld]
	}


 #   coala_bind_help .analyze.canvas "coala_shorthelp ana2_dg_dyn_event.hlp"

}
