# -----------------------------------------------------------------------------$)C
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-A|cken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------


# ===== coala_display_termination_reason
# ===== shows the termination reason of all negotiations on the canvas

proc coala_display_sim_termination_reason {} {
	global c_font simulation_name

	set w .analyze
	destroy $w.f1

	# ===== clear canvas
	eval .analyze.canvas delete [.analyze.canvas find all]

	set logfile [open "logs/$simulation_name\.stat\.log" r]
	gets $logfile line
	close $logfile
	# ===== read termination reasons
	set total_neg [lindex $line 0]
	for {set n 0} {$n <= 2} {incr n} {
		set reason($n) [lindex $line [expr $n + 4]]
	}

	# ===== title for the canvas
	.analyze.canvas create text 10 20 -text "Termination Reason" -anchor nw -font $c_font
    coala_bind_help .analyze.canvas "coala_shorthelp ana2_dg_term_reason.hlp"
	.analyze.canvas create text 10 35 -text "Number of Negotiations : $total_neg" -anchor nw -font $c_font

	# ====== colors for the reasons
	set o_colors {blue red green}

	# ====== circle position and size
	set cx 200
	set cy 110
	set cr 140

	set reasontext {"Timeout" "Great Coalition" "No Change of Structure"}
	set olddegree 0
	# ====== drawing circle diagram
	for {set n 0} {$n <= 2} {incr n} {
		if {$reason($n) == 0} {
			continue
		}
		set id [.analyze.canvas create arc $cx $cy [expr $cx+2*$cr] [expr $cy+2*$cr] -fill [lindex $o_colors [expr ($n - 1) % [llength $o_colors]]] -style pieslice \
				-start $olddegree -extent [expr 359.999*(1.0*$reason($n)/$total_neg)]]
	
		set desc_point_x  [expr int((cos([expr -3.1415927*($olddegree/180.0+1.0*$reason($n)/$total_neg)]))*$cr/2+$cx+$cr)]
		set desc_point_y  [expr int((sin([expr -3.1415927*($olddegree/180.0+1.0*$reason($n)/$total_neg)]))*$cr/2+$cy+$cr)]
	
		set out_point_x [expr int((cos([expr -3.1415927*($olddegree/180.0+1.0*$reason($n)/$total_neg)]))*$cr*1.7+$cx+$cr)]
		set out_point_y [expr int((sin([expr -3.1415927*($olddegree/180.0+1.0*$reason($n)/$total_neg)]))*$cr*1.7+$cy+$cr)]
	
		.analyze.canvas create line $desc_point_x $desc_point_y $out_point_x $out_point_y 

		incr out_point_x -60
		incr out_point_y -20

		.analyze.canvas create rectangle $out_point_x $out_point_y [expr $out_point_x+140] [expr $out_point_y + 40] -fill white
		.analyze.canvas create text [expr $out_point_x+3] [expr $out_point_y + 3] -text [lindex $reasontext $n] -anchor nw -font $c_font
		.analyze.canvas create text [expr $out_point_x+3] [expr $out_point_y + 23] -text "$reason($n) negotiations ([expr int(100.0*$reason($n)/$total_neg+0.5)]%)"	 \
				-anchor nw -font $c_font
	
		set olddegree [expr 360.0*(1.0*$reason($n)/$total_neg)+$olddegree]
	}

	# ====== adjust scrollregion
	coala_adjust_analyze_canvas
}


