# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-Acken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ===== coala_message:
# ===== Displays a dialog-window, waits for button-press

proc coala_message {title text} {
    global tk_priv
    
    set w .dialog
    catch {destroy $w}
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    frame $w.top 
    pack $w.top -side top -fill both -padx 5m -pady 5m
    frame $w.bot 
    pack $w.bot -side bottom -fill both -ipady 2m

	global on_unix
	if {$on_unix} {
		message $w.msg	 -text $text \
				-font -Adobe-Times-Medium-R-Normal-*-180-* \
				-width 300 
		pack $w.msg -in $w.top -expand 1 -fill both
	} else {
		global c_font
		message $w.msg	 -text $text \
				-font $c_font -width 300 
		pack $w.msg -in $w.top -expand 1 -fill both
	}

    button $w.ok -text "OK" -command "set tk_priv(button) 1; destroy $w" -width 8
    pack $w.ok -in $w.bot -ipady 2m 
    bind $w <Return> "$w.ok invoke"

    # ===== place window
    wm withdraw $w
    update idletasks
    set dad [winfo parent $w]

    if {([set dadX [winfo x $dad]] == 0) || ([set dadY [winfo y $dad]] == 0)} {
      set x 300
      set y 200
    } else {
      set x [expr $dadX + ([winfo reqwidth $dad] - [winfo reqwidth $w])/2]
      set y [expr round($dadY + [winfo reqheight $dad]*0.3)]
    }

    wm geom $w +$x+$y
    wm deiconify $w

    # ===== wait for button
    catch {grab $w}
    set oldFocus [focus]
    focus $w

    set tk_priv(button) -1
    tkwait window $w
    grab release $w
	global on_unix
	if {$on_unix} {
		focus $oldFocus
	}
    update 
}