# -----------------------------------------------------------------------------
# Copyright (c) 2009 by Christine Walter, Matthias Klusch
# Saarland University and German Research Center for Artificial Intelligence,
# Saarbruecken, Germany
#
# All rights reserved. No warranties will be given on any issues arising out 
# of the use of this software product. Permission to use, copy, modify and 
# distribute this software product for non-commercial purposes is hereby 
# granted, provided that the above copyright notice appears in all copies and 
# respective publications.
# All commercial trades with this product without specific written prior 
# permission are prohibited.
# -----------------------------------------------------------------------------


# -- if rep of coal is opportunist, they know their own real rel_infos
proc coala_opp_calc_real_coal_value {coal rep} {
	global v_func infos_in_nego trick_rel_infos_in_nego

	set coal_value 0
	# ===== foreach agent in the current coal
	foreach agent $coal {
		# ===== foreach infounit(s) this agent has
		if [info exists infos_in_nego($agent)] {
			foreach entry $infos_in_nego($agent) {
				# ===== if this/these unit(s) are accessible for the coalition
				if [info_is_accessible $coal [lindex $entry 1] $agent] {
					# ===== test foreach agent in the coal
					foreach agent2 $coal {
						# ===== for v_a/v_g-CEs: if unit is available for this agent
						if {$v_func == 2} {
							if {[lsearch [lindex $entry 1] $agent2] == -1} {
								# ===== agent will not pay for something he cannot see (get)
								continue
							}
						}
						# ===== if infounit is relevant for this agent =>
						# ===== he will pay for it
						# -- but not if he is opp and rep and it is just a trick
						if {[lsearch [lindex $entry 2] $agent2] != -1} {
							set i [lsearch $infos_in_nego($agent) $entry]
							if {$agent2 == $rep && [coala_is_trick $agent $i $rep]} {
							continue
							}
							# ===== individual price foreach info-unit
							set coal_value [expr $coal_value + [lindex $entry 0]]
						}
					}
				}
			}
		}
	}
	return $coal_value
}


# -- checks if info $no of $agent is part of trick_rel_infos_in_nego(opp_agent)
proc coala_is_trick {owner no opp_agent} {
	global trick_rel_infos_in_nego
	
	foreach trick_info $trick_rel_infos_in_nego($opp_agent) {
		if {[lindex $trick_info 0] == $owner && [lindex $trick_info 1] == $no} {
		return 1
		} 
	}
	return 0
}
 
