# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbrcken, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ===== coala_save
# ===== This script saves the current game

proc coala_save_as {} {

	global filename
	coala_filebrowser_save "Save system"

	if {$filename == ""} {
		return
	}
	
	# ===== test if file already exists
	if [file exists "desc/$filename"] {
		if {[coala_dialog "Message" "File already exists !\nOverwrite ?" center "" top 0 1 "OK" "Cancel"] == 1} {
			return
		}
	}

	# ===== open file
	set file [open "desc/$filename" w]

	global agents_list
	# ===== write number of agents
	puts $file [llength $agents_list]

	# ===== write each agent name 
	foreach agent $agents_list {
		puts $file $agent
	}

	# ===== write options for simulation
	global opt_sim
	puts $file $opt_sim

	# ===== write options for each agent 
	global opt_agent
	foreach agent $agents_list {
		puts $file $opt_agent($agent) 
	}

	# ===== write info-units for each agent 
	global infos
	foreach agent $agents_list {
		if [info exists infos($agent)] {
			puts $file $infos($agent) 
		} else {
			puts $file ""
		}
	}
	# ===== close file
	close $file

	# ===== after save the game has not changed
	global game_has_changed
	set game_has_changed 0

	# ===== set simulation name
	global simulation_name
	set simulation_name [string range $filename 0 [expr [string length $filename] - 5]]
	wm title . "COALA3 \[$simulation_name\]"
	global description_window_title
	set description_window_title "Settings for Simulation \[$simulation_name\]"
	# ===== enable 'save' menu
	.mbar.file.menu entryconfigure 3 -state normal
}


