# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-A|cken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ===== This script opens a window for setting the information-units and tasks
# ===== of each agent

proc coala_set_info_unit {} {

    set w .set_infos
    catch {
		destroy $w
    }

    # ===== create new window
    toplevel $w
	wm title $w "Set Information-Units of Agents"
    wm iconname $w "COALA"
    wm geometry $w +20+100

    # ===== frames
    frame $w.f1 -relief ridge -bd 2
    pack $w.f1 -side left -fill both -expand 1
    frame $w.f2 -relief ridge -bd 2
    pack $w.f2 -side left -fill both -expand 1
    frame $w.f3 -relief ridge -bd 2
    pack $w.f3 -side left -fill both -expand 1


    # ===== left scrollbar/listbox (agents who have information)  
    label $w.l1 -text "Agent"
    pack $w.l1 -side top -fill x -in  $w.f1
    scrollbar $w.scroll1 -command "$w.agents_list yview"
    listbox $w.agents_list -yscroll "$w.scroll1 set" \
	-relief raised -exportselection no -height 20 -width 15 -selectmode single
    coala_bind_help $w.agents_list "coala_shorthelp set_info_unit_agent.hlp" 
    coala_bind_help $w.l1 "coala_shorthelp set_info_unit_agent.hlp"
    
    pack $w.agents_list -side left -fill both -expand 1 -in $w.f1
    pack $w.scroll1 -side right -fill y -in $w.f1
    
    bind $w.agents_list <ButtonRelease-1> {
		set agent [.set_infos.agents_list get [.set_infos.agents_list curselection]]
		.set_infos.b1 configure -text "New Information-Unit\nfor Agent $agent" -command "coala_new_info_unit"
		coala_bind_help .set_infos.b1 "coala_shorthelp set_info_unit_new.hlp"
		coala_fill_info_list $agent
    }
    
    # ===== right scrollbar/listbox (# infounits, who want this info, accessible for)
	global agents_list
	global infolist_text
	set infolist_text " " 
    label $w.l2 -textvariable infolist_text
    pack $w.l2 -side top -fill x -in $w.f2
    scrollbar $w.scroll2 -command "$w.info_list yview"    
    scrollbar $w.scroll3 -command "$w.info_list xview" -orient horizontal
    listbox $w.info_list -yscroll "$w.scroll2 set" -xscroll "$w.scroll3 set" \
	-relief raised -exportselection no -height 20 -width 35 -selectmode single

    coala_bind_help $w.l2 "coala_shorthelp set_info_unit_list.hlp" 
    coala_bind_help $w.info_list "coala_shorthelp set_info_unit_list.hlp" 

    pack $w.scroll3 -side bottom -fill x -in $w.f2     
    pack $w.info_list -side left -fill both -expand 1 -in $w.f2
    pack $w.scroll2 -side right -fill y -in $w.f2


    # ===== Command Buttons
    button $w.b1 -text "New Information-Unit\nfor Agent [lindex $agents_list 0]" -command {coala_new_info_unit}
	coala_bind_help .set_infos.b1 "coala_shorthelp set_info_unit_new.hlp"
    pack $w.b1 -fill x -in $w.f3

	button $w.b2 -text "Edit selected\nInformation-Unit" -command {
		if {[.set_infos.info_list curselection] >= 0 && [.set_infos.info_list curselection] < [.set_infos.info_list size]} {
			coala_change_info_unit
		} else {
			coala_message "Error" "Please Select an Item"
		}
    }
	coala_bind_help .set_infos.b2 "coala_shorthelp set_info_unit_edit.hlp"
	pack $w.b2 -fill x -in $w.f3

    button $w.b3 -text "Delete selected\nInformation-Unit"  -command {
		# ===== delete the selected information units
		if {[.set_infos.info_list curselection] >= 0 && [.set_infos.info_list curselection] < [.set_infos.info_list size]} {
			global infos
			set agent [.set_infos.agents_list get [.set_infos.agents_list curselection]]
			# ===== delete entry in global variable infos
			set infos($agent) [coala_ldelete $infos($agent) [.set_infos.info_list curselection]]
			# ===== show new infos
			coala_fill_info_list $agent

			# ===== the game has changed
			global game_has_changed
			set game_has_changed 1	    
			# ===== previous simulation is not valid 
			global simulated
			set simulated 0
			# ===== disable analyze buttons 
			.top.right.analyze1 configure -state disabled	
			.top.right.analyze2 configure -state disabled	
		} else {
			coala_message "Error" "Please Select an Item"
		}
    }
    pack $w.b3 -fill x -in $w.f3
    coala_bind_help $w.b3 "coala_shorthelp set_info_unit_delete.hlp"

    button $w.b4 -text "Back" -command {
	    destroy .set_infos
		coala_fill_description
    }
    pack $w.b4 -fill x -in $w.f3
    coala_bind_help $w.b4 "coala_shorthelp set_info_unit_back.hlp"

    # ===== fill left listbox
    foreach agent $agents_list {
		$w.agents_list insert end $agent
    }
    
    $w.agents_list selection clear 0 end
    $w.agents_list selection set 0

    # ===== display infos for agent with index 0
    coala_fill_info_list [lindex $agents_list 0]

	# ===== grab focus
	focus $w
	focus $w.b1
	update
	grab $w
  
	tkwait window $w
}


# ===== fills the info list (right listbox) with infos for agent number n
proc coala_fill_info_list {agent} {
    global infos
	global infolist_text
	set infolist_text "Information-Units of $agent :"
 
    .set_infos.info_list delete 0 end
    catch {
		set i 1
		foreach entry $infos($agent) {
			set access {}
			set j 0
			foreach access_agent [lindex $entry 1] {
				if {$j == 11} {
					lappend access "..."
					break
# at most 11 of the agents that have access to the info-unit are listed in the widget
				}
				if {$access_agent != $agent} {
					lappend access $access_agent
					incr j
				}
			}
			.set_infos.info_list insert end "\[Info-Unit $i\] Price : [lindex $entry 0], Accessible for : $access"
			incr i
		}
    }
    bind .set_infos.info_list <Double-Button-1> {
		if {[.set_infos.info_list curselection] >= 0 && [.set_infos.info_list curselection] < [.set_infos.info_list size]} {
			# ===== open window and let user change the values
			coala_change_info_unit 
		}
    }

    coala_check_list .set_infos.info_list 10
    coala_check_list .set_infos.agents_list 10
}


# ===== opens window and asks for new infounits (+availability)
proc coala_new_info_unit {} {
    set w .new_info
    catch {
		destroy $w
    }
    
    toplevel $w
	
	global owner
	set owner [.set_infos.agents_list get [.set_infos.agents_list curselection]]
    wm title $w "New Info-Unit for $owner"
	
    # ====== frames
    frame $w.f1 -relief ridge -bd 2
    frame $w.f2 -relief ridge -bd 2
    frame $w.f3

	pack $w.f1 -fill x -side top 
	pack $w.f2 -fill both 
	pack $w.f3 -side bottom -fill x

    # ====== entry field for Price
    label $w.l1 -text "Price :"
    entry $w.e1
    pack $w.l1 -side left -in $w.f1
    pack $w.e1 -side left -fill x -in $w.f1
    coala_bind_help $w.l1 "coala_shorthelp set_info_unit_price.hlp"    
    coala_bind_help $w.e1 "coala_shorthelp set_info_unit_price.hlp"
    
    # ===== accessible for list
    label $w.l2 -text "Accessible for:"
    scrollbar $w.scroll1 -command "$w.access_list yview"
    listbox $w.access_list -yscroll "$w.scroll1 set" \
	-relief raised -exportselection no -height 15 -width 7 -selectmode extended
    
    pack $w.l2 -fill x -side top -in $w.f2
    pack $w.access_list -side left -fill both -expand 1 -in $w.f2
    pack $w.scroll1 -side right -fill y -in $w.f2
    coala_bind_help $w.l2 "coala_shorthelp set_info_unit_access.hlp"
    coala_bind_help $w.access_list "coala_shorthelp set_info_unit_access.hlp"

    # ===== fill lists
	global agents_list
    foreach agent $agents_list {
		if {$agent != $owner} {
			$w.access_list insert end $agent
		}
    }
    
    # ===== adjust widths
    coala_check_list $w.access_list 7

    # ===== select all
    $w.access_list selection set 0 end

    # ===== command buttons
    button $w.ok -text "OK" -command { 
		if ![coala_int [.new_info.e1 get]] {
			coala_message "ERROR" "Please insert an Integer !"
		} else {
			global owner
			set agent [.set_infos.agents_list get [.set_infos.agents_list curselection]]
			set access {}
			foreach index [.new_info.access_list curselection] {
				lappend access [.new_info.access_list get $index]
			}
			lappend access $owner
			set access [lsort $access]
			lappend infos($agent) [list [.new_info.e1 get] $access {}]	    

			# ====== show new entry
			coala_fill_info_list $agent
			
			# ===== close window
			destroy .new_info
			
			# ===== the game has changed
			global game_has_changed
			set game_has_changed 1	    

			# ===== previous simulation is not valid 
			global simulated
			set simulated 0
			# ===== disable analyze buttons 
			.top.right.analyze1 configure -state disabled	
			.top.right.analyze2 configure -state disabled	
		}
    }

    button $w.cancel -text "Cancel" -command {
		# ===== close window
		destroy .new_info
    }

    bind $w <Return> "$w.ok invoke"
    bind $w <Escape> "$w.cancel flash; $w.cancel invoke"

    pack $w.ok -side left -in $w.f3
    pack $w.cancel -side right -in $w.f3
    coala_bind_help $w.ok "coala_shorthelp set_info_unit_new_ok.hlp"
    coala_bind_help $w.cancel "coala_shorthelp set_info_unit_new_cancel.hlp"

    # ===== grab focus
    focus $w
    focus $w.e1
    update
    grab $w
  
    tkwait window $w

    # ===== give focus back
    grab .set_infos
}

# ===== opens window and asks for changing the setting of infounits 
proc coala_change_info_unit {} {
    grab release .set_infos
    set w .edit_info
    catch {
		destroy $w
    }
    
    toplevel $w

	global agents_list owner
	set owner [lindex $agents_list [.set_infos.agents_list curselection]]
    wm title $w "Edit Info-Unit for $owner"

    # ====== frames
    frame $w.f1 -relief ridge -bd 2
    frame $w.f2 -relief ridge -bd 2
    frame $w.f3

    pack $w.f1 -fill x -side top 
    pack $w.f2 -fill both 
    pack $w.f3 -side bottom -fill x

    # ====== entry field for Price
    label $w.l1 -text "Price :"
    entry $w.e1
    pack $w.l1 -side left -in $w.f1
    pack $w.e1 -side left -fill x -in $w.f1
    coala_bind_help $w.l1 "coala_shorthelp set_info_unit_price.hlp"    
    coala_bind_help $w.e1 "coala_shorthelp set_info_unit_price.hlp"

    # ===== accessabilty list
    label $w.l2 -text "Accessible for:"
    scrollbar $w.scroll1 -command "$w.access_list yview"
    listbox $w.access_list -yscroll "$w.scroll1 set" \
	-relief raised -exportselection no -height 20 -width 15 -selectmode extended
    
    pack $w.l2 -fill x -side top -in $w.f2
    pack $w.access_list -side left -fill both -expand 1 -in $w.f2
    pack $w.scroll1 -side right -fill y -in $w.f2
    coala_bind_help $w.l2 "coala_shorthelp set_info_unit_access.hlp"
    coala_bind_help $w.access_list "coala_shorthelp set_info_unit_access.hlp"
    
    # ===== fill lists
	set i [lsearch $agents_list $owner]
	set agents [lreplace $agents_list $i $i]
	
    foreach agent $agents {
		if {$agent != $owner} {
			$w.access_list insert end $agent
		}
    }

    # ===== adjust widths
    coala_check_list $w.access_list 10

    # ===== set "old" values
    global infos
	set agent [.set_infos.agents_list get [.set_infos.agents_list curselection]]
    set entry_to_change [lindex $infos($agent) [.set_infos.info_list curselection]]
    foreach access_agent [lindex $entry_to_change 1] {
		$w.access_list selection set [lsearch $agents $access_agent]
    }

    $w.e1 delete 0 end
    $w.e1 insert 0 [lindex $entry_to_change 0]

    # ===== command buttons
    button $w.ok -text "OK" -command { 
		if ![coala_int [.edit_info.e1 get]] {
			coala_message "Error" "Please insert an Integer !"
			return
		}
		global infos owner

		set agent [.set_infos.agents_list get [.set_infos.agents_list curselection]]
		set access {}
		foreach index [.edit_info.access_list curselection] {
			lappend access [.edit_info.access_list get $index]
		}
		lappend access $owner
		set access [lsort $access]
		set selected [.set_infos.info_list curselection]
		
		# ===== replace "old" values with new ones
		set infos($agent) [lreplace $infos($agent) $selected $selected [list [.edit_info.e1 get] $access {}]]
		# ====== show new entry
		coala_fill_info_list $agent
	    
		# ===== close window
		destroy .edit_info
		
		# ===== the game has changed
		global game_has_changed
		set game_has_changed 1	    
		
		# ===== previous simulation is not valid 
		global simulated
		set simulated 0
		# ===== disable analyze buttons 
		.top.right.analyze1 configure -state disabled	
		.top.right.analyze2 configure -state disabled	
    }

    button $w.cancel -text "Cancel" -command {
		# ===== close window
		destroy .edit_info
    }

    bind $w <Return> "$w.ok invoke"
    bind $w <Escape> "$w.cancel flash; $w.cancel invoke"

    pack $w.ok -side left -in $w.f3
    pack $w.cancel -side right -in $w.f3
    coala_bind_help $w.ok "coala_shorthelp set_info_unit_new_ok.hlp"
    coala_bind_help $w.cancel "coala_shorthelp set_info_unit_new_cancel.hlp"

    # ===== grab focus
    focus $w
    focus $w.e1
    update
    grab $w

    tkwait window $w

    # ===== give focus back
    grab .set_infos
}


